<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: controllers/UserController.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: controllers/UserController.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const UserService_1 = require("../services/UserService");
/**
 * User Controller receives all user requests and forwards &lt;/br>
 * them to the User Service.
 * @class
 * @author Farooq Ilyas
 */
class UserController {
    /**
     * Forwards a request to create a user
     * @param {Request} req request
     * @param {Response} res response
     * @param {Function} next next request handler
     * @returns {UserInstance} upon successful creation
     * @returns {Error} upon an error
     */
    create(req, res, next) {
        UserService_1.userService.create(req.body)
            .then((user) => {
            return res.send(user);
        }).catch((error) => {
            next(error);
        });
    }
    /**
     * Forwards a request to retrieve all users
     * @param {Request} req request
     * @param {Response} res response
     * @param {Function} next next request handler
     * @returns {UserInstance[]} upon successful retrieval
     * @returns {Error} upon an error
     */
    retrieve(req, res, next) {
        UserService_1.userService.retrieve().
            then((users) => {
            if (users.length)
                return res.send(users);
            next(new Error("NO_DATA"));
        }).catch((error) => {
            next(error);
        });
    }
    /**
     * Forwards a request to retrieve a user given the userId
     * @param {Request} req request
     * @param {Response} res response
     * @param {Function} next next request handler
     * @returns {UserInstance} upon successful retrieval
     * @returns {Error} upon error
     */
    retrieveById(req, res, next) {
        UserService_1.userService.retrieveById(req.params.userID)
            .then((user) => {
            return res.send(user);
        }).catch((error) => {
            next(error);
        });
    }
    /**
     * Forwards a request to delete a user given the id
     * @param {Request} req request
     * @param {Response} res response
     * @param {Function} next next request handler
     * @returns {number} number of rows deleted
     * @returns {Error} upon an error
     */
    delete(req, res, next) {
        UserService_1.userService.delete(req.params.userID)
            .then((deletedRows) => {
            return res.send(deletedRows);
        }).catch((error) => {
            next(error);
        });
    }
    /**
     * Forwards a request to update a user given the id
     * @param {Request} req request
     * @param {Response} res response
     * @param {Function} next next request handler
     * @returns {UserInstance} upon successful update
     * @returns {Error} upon an error
     */
    update(req, res, next) {
        UserService_1.userService.update(req.params.userId, req.body)
            .then((user) => {
            return res.send(user);
        }).catch((error) => {
            next(error);
        });
    }
}
exports.UserController = UserController;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="BaseRouter.html">BaseRouter</a></li><li><a href="Configs.html">Configs</a></li><li><a href="CustomErrorHandler.html">CustomErrorHandler</a></li><li><a href="Database.html">Database</a></li><li><a href="DBConfig.html">DBConfig</a></li><li><a href="LoggingConfiguration.html">LoggingConfiguration</a></li><li><a href="Middleware.html">Middleware</a></li><li><a href="Server.html">Server</a></li><li><a href="ServerConfiguration.html">ServerConfiguration</a></li><li><a href="UserController.html">UserController</a></li><li><a href="UserModel.html">UserModel</a></li><li><a href="UserRouter.html">UserRouter</a></li><li><a href="UserService.html">UserService</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Mon Jul 02 2018 23:16:09 GMT+0100 (GMT Daylight Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
